 .\" 
.\" Mach Operating System
.\" Copyright (c) 1993,1991,1990 Carnegie Mellon University
.\" All Rights Reserved.
.\" 
.\" Permission to use, copy, modify and distribute this software and its
.\" documentation is hereby granted, provided that both the copyright
.\" notice and this permission notice appear in all copies of the
.\" software, derivative works or modified versions, and any portions
.\" thereof, and that both notices appear in supporting documentation.
.\" 
.\" CARNEGIE MELLON ALLOWS FREE USE OF THIS SOFTWARE IN ITS "AS IS"
.\" CONDITION.  CARNEGIE MELLON DISCLAIMS ANY LIABILITY OF ANY KIND FOR
.\" ANY DAMAGES WHATSOEVER RESULTING FROM THE USE OF THIS SOFTWARE.
.\" 
.\" Carnegie Mellon requests users of this software to return to
.\" 
.\"  Software Distribution Coordinator  or  Software.Distribution@CS.CMU.EDU
.\"  School of Computer Science
.\"  Carnegie Mellon University
.\"  Pittsburgh PA 15213-3890
.\" 
.\" any improvements or extensions that they make and grant Carnegie Mellon
.\" the rights to redistribute these changes.
.\" 
.\" 
.\" HISTORY
.\" $Log:	processor_set_policy_add.man,v $
.\" Revision 2.2  93/12/07  13:56:52  dbg
.\" 	Created.
.\" 
.\" 
.TH processor_set_policy_add 2 9/22/93
.CM 4
.SH NAME
.nf
processor_set_policy_add  \-  enable scheduling policy on processor set
processor_set_policy_remove  \-  disable scheduling policy on processor set
.SH SYNOPSIS
.nf
.ft B
#include <mach.h>

.nf
.ft B
kern_return_t
processor_set_policy_add(
	mach_port_t processor_set,
	int		policy,
	policy_param_t	limit,
	natural_t	limit_count);


.fi
.ft P
.nf
.ft B
kern_return_t
processor_set_policy_remove(
	mach_port_t   	processor_set,
	int             policy);




.fi
.ft P
.SH ARGUMENTS
.TP 15
.B
processor_set
The processor set whose allowed policies are to be changed.
.TP 15
.B
policy
The policy to enable or disable.

.SH DESCRIPTION
Processor sets may restrict the scheduling policies to be used for
threads assigned to them.  These two calls provide the mechanism for
designating permitted and forbidden policies.  The current set of
permitted policies can be obtained from 
.B processor_set_info.
Background may not
be forbidden by any processor_set.  This is a compromise to reduce the
complexity of the assign operation; any thread whose policy is forbidden by
the target processor set has its policy reset to timesharing, or
to background if
timesharing is not enabled.

<mach/policy.h> contains the allowed policies; it is included by mach.h.
<mach/rt_policy.h> contains additional policies used by real-time threads.

.SH DIAGNOSTICS
.TP 25
KERN_SUCCESS
Operation completed successfully
.TP 25
KERN_INVALID_ARGUMENT
.B processor_set
is not a processor set,
or 
.B policy
is not a valid policy, or an attempt was made to disable background.

.SH BUGS
Not all policies (e.g. real-time policies) are supported
by all systems.

.SH SEE ALSO
.B thread_policy, task_policy

