 .\" 
.\" Mach Operating System
.\" Copyright (c) 1993 Carnegie Mellon University
.\" All Rights Reserved.
.\" 
.\" Permission to use, copy, modify and distribute this software and its
.\" documentation is hereby granted, provided that both the copyright
.\" notice and this permission notice appear in all copies of the
.\" software, derivative works or modified versions, and any portions
.\" thereof, and that both notices appear in supporting documentation.
.\" 
.\" CARNEGIE MELLON ALLOWS FREE USE OF THIS SOFTWARE IN ITS "AS IS"
.\" CONDITION.  CARNEGIE MELLON DISCLAIMS ANY LIABILITY OF ANY KIND FOR
.\" ANY DAMAGES WHATSOEVER RESULTING FROM THE USE OF THIS SOFTWARE.
.\" 
.\" Carnegie Mellon requests users of this software to return to
.\" 
.\"  Software Distribution Coordinator  or  Software.Distribution@CS.CMU.EDU
.\"  School of Computer Science
.\"  Carnegie Mellon University
.\"  Pittsburgh PA 15213-3890
.\" 
.\" any improvements or extensions that they make and grant Carnegie Mellon
.\" the rights to redistribute these changes.
.\" 
.\" 
.\" HISTORY
.\" $Log:	timer_cancel.man,v $
.\" Revision 2.2  93/12/07  14:01:03  dbg
.\" 	Created.
.\" 
.\" 
.TH timer_cancel 2 9/22/93
.CM 4
.SH NAME
.nf
timer_cancel  \-  cancel a timer expiration (disarm a timer)
.SH SYNOPSIS
.nf
.ft B
#include <mach.h>

.nf
.ft B
kern_return_t
timer_cancel(
	mach_timer_t	timer,
	int		flags);


.fi
.ft P
.SH ARGUMENTS
.TP 15
.B
timer
The timer to disarm.
.TP 15
.B flags
Whether to cancel one or all expirations of a
periodic timer.


.SH DESCRIPTION
.B timer_cancel
disarms a currently armed timer.  If the timer has been
armed with timer_arm, the expiration message will not
be sent.  If a thread is sleeping on the timer, the
thread will be awakened immediately.

If the timer has been armed to expire periodically,
.B flags
selects whether to cancel only the next expiration (if
.B TIMER_PERIODIC
is set in 
.B flags)
or to cancel all expirations.  If only the current expiration
is canceled, the timer is set to expire at the end of the
next period.

.SH DIAGNOSTICS
.TP 25
KERN_SUCCESS
Operation completed successfully
.TP 25
KERN_INVALID_ARGUMENT
.B timer
is not a timer
.TP 25
KERN_FAILURE
.B timer
is not currently armed.

.SH BUGS

.SH SEE ALSO
.B timer_create, timer_terminate, timer_arm, timer_sleep.

