 .\" 
.\" Mach Operating System
.\" Copyright (c) 1993 Carnegie Mellon University
.\" All Rights Reserved.
.\" 
.\" Permission to use, copy, modify and distribute this software and its
.\" documentation is hereby granted, provided that both the copyright
.\" notice and this permission notice appear in all copies of the
.\" software, derivative works or modified versions, and any portions
.\" thereof, and that both notices appear in supporting documentation.
.\" 
.\" CARNEGIE MELLON ALLOWS FREE USE OF THIS SOFTWARE IN ITS "AS IS"
.\" CONDITION.  CARNEGIE MELLON DISCLAIMS ANY LIABILITY OF ANY KIND FOR
.\" ANY DAMAGES WHATSOEVER RESULTING FROM THE USE OF THIS SOFTWARE.
.\" 
.\" Carnegie Mellon requests users of this software to return to
.\" 
.\"  Software Distribution Coordinator  or  Software.Distribution@CS.CMU.EDU
.\"  School of Computer Science
.\"  Carnegie Mellon University
.\"  Pittsburgh PA 15213-3890
.\" 
.\" any improvements or extensions that they make and grant Carnegie Mellon
.\" the rights to redistribute these changes.
.\" 
.\" 
.\" HISTORY
.\" $Log:	timer_create.man,v $
.\" Revision 2.2  93/12/07  14:01:19  dbg
.\" 	Created.
.\" 
.\" 
.TH timer_create 2 9/22/93
.CM 4
.SH NAME
.nf
timer_create  \-  create a timer.
.SH SYNOPSIS
.nf
.ft B
#include <mach.h>

.nf
.ft B
kern_return_t
timer_create(
	mach_clock_t	clock,
	mach_timer_t	*timer);		/* out */


.fi
.ft P
.SH ARGUMENTS
.TP 15
.B
clock
The clock device to provide timekeeping for the timer.
.TP 15
.B
timer
Returns the newly created timer.

.SH DESCRIPTION
A timer is based on a particular clock device, which provides
timekeeping for that timer at a particular (or selectable) resolution.
.B timer_create 
creates a timer based on the supplied clock device.

.SH DIAGNOSTICS
.TP 25
KERN_SUCCESS
Operation completed successfully
.TP 25
KERN_INVALID_ARGUMENT
.B clock
is not a clock device.

.SH BUGS

.SH SEE ALSO
.B timer_terminate, timer_arm, timer_sleep, timer_cancel.

