 .\" 
.\" Mach Operating System
.\" Copyright (c) 1993 Carnegie Mellon University
.\" All Rights Reserved.
.\" 
.\" Permission to use, copy, modify and distribute this software and its
.\" documentation is hereby granted, provided that both the copyright
.\" notice and this permission notice appear in all copies of the
.\" software, derivative works or modified versions, and any portions
.\" thereof, and that both notices appear in supporting documentation.
.\" 
.\" CARNEGIE MELLON ALLOWS FREE USE OF THIS SOFTWARE IN ITS "AS IS"
.\" CONDITION.  CARNEGIE MELLON DISCLAIMS ANY LIABILITY OF ANY KIND FOR
.\" ANY DAMAGES WHATSOEVER RESULTING FROM THE USE OF THIS SOFTWARE.
.\" 
.\" Carnegie Mellon requests users of this software to return to
.\" 
.\"  Software Distribution Coordinator  or  Software.Distribution@CS.CMU.EDU
.\"  School of Computer Science
.\"  Carnegie Mellon University
.\"  Pittsburgh PA 15213-3890
.\" 
.\" any improvements or extensions that they make and grant Carnegie Mellon
.\" the rights to redistribute these changes.
.\" 
.\" 
.\" HISTORY
.\" $Log:	timer_terminate.man,v $
.\" Revision 2.2  93/12/07  14:01:52  dbg
.\" 	Created.
.\" 
.\" 
.TH timer_terminate 2 9/22/93
.CM 4
.SH NAME
.nf
timer_terminate  \-  destroy a timer.
.SH SYNOPSIS
.nf
.ft B
#include <mach.h>

.nf
.ft B
kern_return_t
timer_terminate(
	mach_timer_t	timer);


.fi
.ft P
.SH ARGUMENTS
.TP 15
.B
timer
The timer to destroy.

.SH DESCRIPTION
.B timer_terminate
destroys a timer.  If a thread is sleeping on the timer, the
thread is awakened.  If the timer is armed (by timer_arm),
the event to occur will not happen.

A timer is also terminated if no send rights remain to the
timer's port.

.SH DIAGNOSTICS
.TP 25
KERN_SUCCESS
Operation completed successfully
.TP 25
KERN_INVALID_ARGUMENT
.B timer
is not a timer.

.SH BUGS

.SH SEE ALSO
.B timer_create, timer_arm, timer_sleep, timer_cancel.

